#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
    long int h,n;
    int i,j,l,d,s=0;

    scanf("%ld%ld",&h,&n);
    int vodopad[h+1][n];

    for(i=0; i<n; i++)
        vodopad[0][i] = 1;
    for(i=1; i<=h; i++)
    {
        for(j=0; j<n; j++)
        {
            scanf("%d", &vodopad[i][j]);
        }

    }
    for(i=1; i<=h; i++)
    {
        for(j=0; j<n; j++)
            if(vodopad[i][j]!=0) vodopad[i][j] = vodopad[i-1][j];
        for(j=0; j<n; j++)
        {

            if(vodopad[i][j]==0)
            {
                s+=vodopad[i-1][j];
                if(vodopad[i][j-1]!=0) l=j-1;
                if(vodopad[i][j+1]!=0)
                {
                    d=j+1;
                    if(l<0) vodopad[i][d] += s;
                    else if(d>=n) vodopad[i][l] += s;
                    else if(i%2!=0) { vodopad[i][l] += s/2+s%2; vodopad[i][d] += s/2;}
                    else { vodopad[i][l] += s/2; vodopad[i][d] += s/2+s%2;}
                    s=0;
                }
            }

        }
    }
    for(i=0; i<n; i++) printf("%d ", vodopad[h][i]);
}